<template>
  <v-content>
    <v-container fluid>
      <v-data-table class="elevation-1" hide-actions :headers="headers" :items="products">
        <template slot="items" slot-scope="props">
          <tr
            :class="{'green lighten-5': props.item.isCharity}"
            @click="show = true; selectedProduct = props.item"
          >
            <td>{{props.item.name}}</td>
            <td>{{props.item.amount}}</td>
            <td>{{"€" + calculatePrice(props.item)}}</td>
            <td class="text-sm-left">
              <v-icon @click="remove(props.item)">delete</v-icon>
            </td>
          </tr>
        </template>
        <template slot="footer">
          <td></td>
          <td>Totaal</td>
          <td class="font-weight-bold">€{{totalAmount}}</td>
          <td></td>
        </template>
      </v-data-table>
      <v-divider></v-divider>
      <v-btn @click="checkout" style="width:97.5%" fixed block color="info">afrekenen</v-btn>
    </v-container>
  </v-content>
</template>

<script>
export default {
  mounted() {
    this.products = this.$store.state.shoppingCart.products;
  },

  data() {
    return {
      products: [],
      selectedProduct: null,
      headers: [
        {
          text: "Product",
          value: "product",
          sortable: false
        },
        {
          text: "Aantal",
          value: "Aantal",
          sortable: false
        },
        {
          text: "Prijs",
          value: "prijs",
          sortable: false
        },
        {
          text: "",
          sortable: false
        }
      ]
    };
  },

  methods: {
    calculatePrice(product) {
      return (product.price * product.amount).toFixed(2);
    },

    changeValue(product) {
      clearTimeout(this.onUpdateDatabase);
      this.onUpdateDatabase = setTimeout(this.saveState, 1000);
    },

    remove(product) {
      const wantsToDelete = confirm(
        `Weet u zeker dat u ${product.amount}x ${product.name} wil verwijderen?`
      );
      if (wantsToDelete) {
        this.products = this.products.filter(p => p.id !== product.id);
        this.$store.commit("removeFromCart", product.id);
      }
    },

    async checkout() {
      try {
        await this.$orderService.createOrder(this.products);
        alert("Bedankt voor uw aankoop!");
        this.products = [];
      } catch (e) {
        alert(e);
      }
    },

    download() {
      this.$fileService.download(this.products);
    }
  },

  computed: {
    totalAmount() {
      return this.products
        .reduce((acc, curr) => (acc += curr.price * curr.amount), 0)
        .toFixed(2);
    }
  }
};
</script>

<style>
</style>
